package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;

public class RC2CBCParameter extends ASN1Encodable {
   DERInteger version;
   ASN1OctetString iv;

   public static RC2CBCParameter getInstance(Object o) {
      if (o instanceof ASN1Sequence) {
         return new RC2CBCParameter((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("unknown object in RC2CBCParameter factory");
      }
   }

   public RC2CBCParameter(byte[] iv) {
      RC2CBCParameter var10000 = this;
      super();
      this.version = null;
      DEROctetString var2;
      var2 = new DEROctetString.<init>(iv);
      var10000.iv = var2;
   }

   public RC2CBCParameter(int parameterVersion, byte[] iv) {
      RC2CBCParameter var10000 = this;
      RC2CBCParameter var10001 = this;
      super();
      DERInteger var3;
      var3 = new DERInteger.<init>(parameterVersion);
      var10001.version = var3;
      DEROctetString var4;
      var4 = new DEROctetString.<init>(iv);
      var10000.iv = var4;
   }

   public RC2CBCParameter(ASN1Sequence seq) {
      if (seq.size() == 1) {
         this.version = null;
         this.iv = (ASN1OctetString)seq.getObjectAt(0);
      } else {
         this.version = (DERInteger)seq.getObjectAt(0);
         this.iv = (ASN1OctetString)seq.getObjectAt(1);
      }

   }

   public BigInteger getRC2ParameterVersion() {
      DERInteger var1;
      return (var1 = this.version) == null ? null : var1.getValue();
   }

   public byte[] getIV() {
      return this.iv.getOctets();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      var1 = new ASN1EncodableVector.<init>();
      DERInteger var2;
      if ((var2 = this.version) != null) {
         var1.add(var2);
      }

      var1.add(this.iv);
      return new DERSequence(var1);
   }
}
